package com.iamberry.wechat.service.product;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.iamberry.wechat.core.entity.product.ProductImageText;
import com.iamberry.wechat.face.porduct.ProductImageTextService;
import com.iamberry.wechat.service.product.dao.ProductImageTextDAO;

/**
 * 产品图文 serice实现
 * 2016年4月24日
 * @author 穆再兴
 *
 */
@Service
public class ProductImageTextServiceImpl implements ProductImageTextService {

	@Autowired
	private ProductImageTextDAO productImageTextDAO;
	/**
	 * 为某个产品添加 一条图文信息
	 * 2016年4月24日
	 * @author 穆再兴
	 * @return
	 */
	@Override
	public Integer addProductImageText(ProductImageText productImageText) {
		return productImageTextDAO.addProductImageText(productImageText);
	}

	/**
	 * 根据productId 查出一条图文信息
	 * 2016年4月24日
	 * @author 穆再兴
	 * @param productId
	 * @return
	 */
	public ProductImageText getProductImageTextByProduectId(Integer productId){
		return productImageTextDAO.getProductImageTextByProduectId(productId);
	}
	
	/**
	 * 根据 图文id 修改一个产品的图文信息
	 * 2016年4月24日
	 * @param 穆再兴
	 * @return
	 */
	public Integer updateProductImageTextById(ProductImageText productImageText){
		return productImageTextDAO.updateProductImageTextById(productImageText);
	}
}
