package com.iamberry.wechat.service.questionnaire;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.iamberry.wechat.core.entity.PageBean;
import com.iamberry.wechat.core.entity.questionnaire.QuestionnaireOption;
import com.iamberry.wechat.core.entity.questionnaire.QuestionnairePaper;
import com.iamberry.wechat.core.entity.questionnaire.QuestionnairePaperDto;
import com.iamberry.wechat.core.entity.questionnaire.QuestionnaireQuestion;
import com.iamberry.wechat.face.questionnaire.QuestionnairePaperService;
import com.iamberry.wechat.service.mapper.QuestionnaireOptionMapper;
import com.iamberry.wechat.service.mapper.QuestionnairePaperMapper;
import com.iamberry.wechat.service.mapper.QuestionnaireQuestionMapper;

/**
 * 营养自测-试卷 service实现
 * @author Administrator
 *
 */
@Service
public class QuestionnairePaperServiceImpl implements QuestionnairePaperService {
	@Autowired
	private QuestionnairePaperMapper paperMapper;
	
	
	@Autowired
	private QuestionnaireQuestionMapper questionMapper;
	
	
	@Autowired
	private QuestionnaireOptionMapper optionMapper;

	
	
	

	
	@Override
	public List<QuestionnaireQuestion> getQuestionnaireQuestionList() {
		
		return questionMapper.getQuestionnaireQuestionList();
	}
	
	@Override
	public Integer getQuestionnaireQuestionCount() {
		// TODO Auto-generated method stub
		return questionMapper.getQuestionnaireQuestionCount();
	}


	@Override
	public List<QuestionnaireOption> getOptionByquestionID(Integer questionID) {
		
		return optionMapper.getOptionByquestionID(questionID);
	}

	
	
	
	@Override
	public Integer getQuestionnaireOptionCount() {
		// TODO Auto-generated method stub
		return optionMapper.getQuestionnaireOptionCount();
	}
	
	
	@Override
	public List<QuestionnairePaper> getQuestionnairePaperList(
			QuestionnairePaper QuestionnairePaper) {
		
		return paperMapper.getQuestionnairePaperList(QuestionnairePaper);
	}

	@Override
	public List<QuestionnairePaperDto> getQuestionnairePaperQuesOptiList(
			Integer paperId) {
		
		return paperMapper.getQuestionnairePaperQuesOptiList(paperId);
	}
	
	
	@Override
	public Integer getQuestionnairePaperCount() {
		// TODO Auto-generated method stub
		return paperMapper.getQuestionnairePaperCount();
	}
	
	
	@Override
	public Integer updateQuestionnairePaperByType(QuestionnairePaperDto questionnairePaperdto) {
		// TODO Auto-generated method stub
		return paperMapper.updateQuestionnairePaperByType(questionnairePaperdto);
	}
	
	
	
	
	
	
	
	
	@Override
	public Integer insertQuestionnairePaper(
			QuestionnairePaper QuestionnairePaper) {
		// TODO Auto-generated method stub
		return paperMapper.insertQuestionnairePaper(QuestionnairePaper);
	}

	@Override
	public QuestionnairePaper getQuestionnairePaperById(Integer paperId) {
		// TODO Auto-generated method stub
		return paperMapper.getQuestionnairePaperById(paperId);
	}

	@Override
	public Integer updateQuestionnairePaperById(
			QuestionnairePaper QuestionnairePaper) {
		// TODO Auto-generated method stub
		return paperMapper.updateQuestionnairePaperById(QuestionnairePaper);
	}

	@Override
	public Integer deleteQuestionnairePaperById(Integer paperId) {
		// TODO Auto-generated method stub
		return paperMapper.deleteQuestionnairePaperById(paperId);
	}

	@Override
	public Integer updatePaperQuestionById(QuestionnaireQuestion questionnaireQuestion) {
		// TODO Auto-generated method stub
		return paperMapper.updatePaperQuestionById(questionnaireQuestion);
	}
	
	
	
	
	
}
