<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<!DOCTYPE HTML>
<html>
<head>
<meta charset="utf-8">
<meta name="renderer" content="webkit|ie-comp|ie-stand">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
<meta name="viewport" content="width=device-width,initial-scale=1,minimum-scale=1.0,maximum-scale=1.0,member-scalable=no" />
<meta http-equiv="Cache-Control" content="no-siteapp" />
<!--[if lt IE 9]>
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/html5.js"></script>
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/respond.min.js"></script>
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/PIE_IE678.js"></script>
<![endif]-->
<link href="${pageContext.request.contextPath }/common/admin/css/H-ui.min.css" rel="stylesheet" type="text/css" />
<link href="${pageContext.request.contextPath }/common/admin/css/H-ui.admin.css" rel="stylesheet" type="text/css" />
<link href="${pageContext.request.contextPath }/common/admin/lib/Hui-iconfont/1.0.1/iconfont.css" rel="stylesheet" type="text/css" />
<!--[if IE 6]>
<script type="text/javascript" src="http://lib.h-ui.net/DD_belatedPNG_0.0.8a-min.js" ></script>
<script>DD_belatedPNG.fix('*');</script>
<![endif]-->
<title>用户答题管理</title>
</head>
<body>
<nav class="breadcrumb"><i class="Hui-iconfont">&#xe67f;</i> 首页 <span class="c-gray en">&gt;</span> 用户答题管理 <span class="c-gray en">&gt;</span> 用户答题数据列表 <a class="btn btn-success radius r mr-20" style="line-height:1.6em;margin-top:3px" href="javascript:location.replace(location.href);" title="刷新" ><i class="Hui-iconfont">&#xe68f;</i></a></nav>
<div class="pd-20">
	<div class="text-c">
	<form action="${pageContext.request.contextPath }/admin/answerData/getAllAnswer" method="post" id="searchForm">
		<input type="hidden" name="orderStatus" value="" />
			<input type="answerBabyName" name="answerBabyName" value="${answerBabyName }" placeholder="宝宝昵称" style="width: 300px" class="input-text" >
			<input type="answerBabyAge" name="answerBabyAge" value="${answerBabyAge }" placeholder="宝宝月龄" style="width: 300px" class="input-text" maxlength="14" onkeyup='this.value=this.value.replace(/\D/gi,"")'>
			<button name="" id="submitBtn" class="btn btn-success" type="submit">
				<i class="Hui-iconfont">&#xe665;</i> 搜索
			</button>
			
		<div class="mt-20">
			<table class="table table-border table-bordered table-hover table-bg">
				<thead>
					<tr class="text-c">
						<th width="30">宝宝id</th>
						<th width="50">宝宝昵称</th>
						<th width="50">宝宝头像</th>
						<th width="30">宝宝性别</th>
						<th width="40">宝宝身长</th>
						<th width="40">宝宝体重</th>
						<th width="40">宝宝头围</th>
						<th width="40">宝宝月龄</th>
						<!-- <th width="40">是否顺产</th>
						<th width="40">是否足月</th> -->
						<th width="40">时间</th>
						<th width="40">用户分数</th>
						<th width="40">浏览次数</th>
						<th width="40">分享次数</th>
						<th width="40">答题备注</th>
						<th width="120">操作</th>
					</tr>
				</thead>
				
				<tbody>
					<c:if test="${!empty answerList }">
						<c:forEach items="${answerList }" var="answer">
						<tr class="text-c">
							<td>${answer.answerId }</td>
							<td>${answer.answerBabyName }</td>
							<td><img src="${answer.answerBabyPic }" width="50" height="50"></img></td>
							<td>
								<c:if test="${answer.answerBabySex == 1}">男孩</c:if>
								<c:if test="${answer.answerBabySex == 2}">女孩</c:if>
							</td>
							<td>${answer.answerBabyHeight }（毫米）</td>
							<td>${answer.answerBabyWeight }（克）</td>
							<td>${answer.answerHeadWith }（毫米）</td>
							<td>${answer.answerBabyAge }（月）</td>
							<%-- <td>
								<c:if test="${answer.answerIsEutocia == 1}">顺产</c:if>
								<c:if test="${answer.answerIsEutocia == 2}">非顺产</c:if>
							</td>
							<td>
								<c:if test="${answer.answerIsFullmoon == 1}">足月</c:if>
								<c:if test="${answer.answerIsFullmoon == 2}">非足月</c:if>
							</td> --%>
							
							<td><fmt:formatDate value="${answer.answerCreateDate }" pattern="YYYY-MM-dd HH:MM:ss"/></td>
							<td>${answer.answerUserScore }</td>
							<td>${answer.answerScannedNumber }</td>
							<td>${answer.answerShareNumber }</td>
							<td>${answer.answerRemark }</td>
							<td class="td-manage">
							<input id="" class="btn btn-primary radius upload-btn" onclick="selectDetails('查看用户回答详情','${pageContext.request.contextPath }/admin/answerData/getAnswerDetailed?answerId=${answer.answerId }','','700');" type="button" value="回答详情" />&nbsp;
							</td>
							
						</tr>
						</c:forEach>
					</c:if>
					<c:if test="${empty answerList }">
						<tr class="text-c">
							<td colspan="9">没有查询到数据</td>
						</tr>
					</c:if>
				</tbody>
			</table>
		</div>
	</form>
	</div>
</div>
<div align="right">
	<%@include file="/common/other/paper/pager.jsp"%>
</div>
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/jquery/1.9.1/jquery.min.js"></script> 
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/layer/1.9.3/layer.js"></script>
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/laypage/1.2/laypage.js"></script> 
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/My97DatePicker/WdatePicker.js"></script> 
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/lib/datatables/1.10.0/jquery.dataTables.min.js"></script> 
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/js/H-ui.js"></script> 
<script type="text/javascript" src="${pageContext.request.contextPath }/common/admin/js/H-ui.admin.js"></script> 
<script type="text/javascript">
$(function() {
	$("#searchButton").click(function() {
		var action = $("#searchForm").attr("action");
		$("#searchForm").attr("action", action).submit();
	});
}) 
/*题目选项查看*/
function selectDetails(title,url,id,w,h){
	layer_show(title,url,w,h);
}
</script> 
</body>
</html>